﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CAN_2024C_demo
{
    public partial class Form1 : Form
    {
        Byte VxCAN_port;
        public Form1()
        {
            InitializeComponent();
        }
        //get VxCAN_DotNET.dll version
        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            }
        }


        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();
            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort = 0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");



            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0', 50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];

                    //2015C is not a UART module so its VxCAN_COMPortBaudRate = 0xFFFFFFFF
                    //we use -1 to represent that
                    if (_VxCAN_COMPortBaudRate[i] == 0xFFFFFFFF)
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = -1;
                    else
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }
            }
        }
        //default CAN baud rate is 1000Kbps, use that open CAN port
        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((Byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            VxCAN_port = (Byte)dataGridView1.CurrentRow.Index;
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
            comboBox3.SelectedIndex = 0;
        }
        //close CAN port
        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(VxCAN_port);
        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if (ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if (ret == 0)
            {
                MessageBox.Show("Module Status = " + ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        //Start operation mode
        private void button1_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox3.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            ID = 0x000;
            Len = 0x2;
            Data[0] = 0x01;
            Data[1] = DataID;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            MessageBox.Show("CAN2019C is in operation mode!");


        }

        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {

            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox3.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];
            int vo_max = 10, vo_min = -10;
            int channel = (comboBox2.SelectedIndex + 1);
            int AO_type = (comboBox1.SelectedIndex + 0x30);

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x04;
            Data[2] = 0x20;
            Data[3] = (byte)channel;
            Data[4] = (byte)(AO_type);
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            switch (AO_type)
            {
                case 0x30:
                    vo_max = 20;
                    vo_min = 0;
                    break;
                case 0x31:
                    vo_max = 20;
                    vo_min = 4;
                    break;
                case 0x32:
                    vo_max = 10;
                    vo_min = 0;
                    break;
                case 0x33:
                    vo_max = 10;
                    vo_min = -10;
                    break;
                case 0x34:
                    vo_max = 5;
                    vo_min = 0;
                    break;
                case 0x35:
                    vo_max = 5;
                    vo_min = -5;
                    break;
            }
            //Analog output
            //convert volt to 0x000~0x7FF( 0V ~ 10V) or 0x800~0xFFF(-10V ~ 0V)
            Int32 convert;
            double volt = 0;
            volt = double.Parse(textBox1.Text);

            if (volt > vo_max || volt < vo_min)
            {
                MessageBox.Show("Out of range!!");
                convert = 0;
            }

            if (volt >= 0)
                convert = (int)(volt / ((double)vo_max / 32767.0));
            else
            {
                convert = 0xFFFF - (int)(volt / ((double)vo_min / 32768.0)) + 1;
                if (convert == 0x7FFF)
                    convert = 0x8000;
            }
            //set analog output value and send 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x11;
            Data[2] = 0x64;
            Data[3] = (byte)channel;
            Data[4] = (byte)(convert % 256);
            Data[5] = (byte)(convert / 256);
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);


        }


        private void Btn_SendStopMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox3.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];
            int channel = (comboBox2.SelectedIndex + 1);
            int AO_type = (comboBox1.SelectedIndex + 0x30);

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x11;
            Data[2] = 0x64;
            Data[3] = (byte)channel;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
    }
}
